#!C:/Programs/Strawberry/win64/perl/bin/perl.exe -I"."

#######################
#    Maths trainer    #
# ------------------- #
# Logarithm equations #
#######################

use strict; use warnings;

use CGI;
use CGI::Carp "fatalsToBrowser";

my $cgi = new CGI;
print "Content-Type: text/html\n\n";
print '<!DOCTYPE html>', "\n\n";
# -------------------------------------------------------------
# Set $app_dir to the full path of the directory,
# where the template file "equations4.template.html" is located
my $app_dir = "C:\\Programs\\Apache24\\htdocs";
# -------------------------------------------------------------
my $questions; my $question; my $level; my $solentry;
my $equation = ''; my $solution = ''; my $solution1 = ''; my $solution2 = '';
my $usolution; my $usolution1; my $usolution2;
my $evaluation; my $correct; my $correctanswer;
# Get parameters from 'calling' webpage and determine next button-push action
my %params = $cgi->Vars;
my $action = lc($params{'action'});
$action = 'init' unless ($action);
if ($action eq 'init' or $action eq 'new' or $action eq 'start' or $action eq 'next' or $action eq 'check') {
  my $nextaction;
  if ($action eq 'init' or $action eq 'new') {
    if ($action eq 'init') {
      $questions = 10; $level = 3; $solentry = 'fractions';
    }
    else {
      $questions = $params{'hquestions'};
      $level = $params{'level'};
      $solentry = $params{'solentry'};
    }
    $question = 0;
    $nextaction = 'start';
  }
  else {
    $question = $params{'hquestion'};
    if ($action eq 'start' or $action eq 'next') {
      if ($action eq 'start') {
        $questions = $params{'questions'};
        $level = $params{'level'};
        $solentry = $params{'solentry'};
        $correct = 0;
      }
      else {
        $questions = $params{'hquestions'};
        $level = $params{'hlevel'};
        $solentry = $params{'hsolentry'};
        $correct = $params{'hcorrect'};
      }
      $nextaction = 'check';
    }
    elsif ($action eq 'check') {
      $questions = $params{'hquestions'};
      $level = $params{'hlevel'};
      $solentry = $params{'hsolentry'};
      $correct = $params{'hcorrect'};
      if ($question < $questions) {
        $nextaction = 'next';
      }
      else {
        $nextaction = 'new';
      }
    }
  }
  # XSS protection: Potential risk characters removal and variable check!
  $questions =~ s/[^0-9]*//g; $level =~ s/[^0-3]//g; $solentry =~ s/[^a-z]*//g;
  $question =~ s/[^0-9]*//g; $correct =~ s/[^0-9]*//g;
  unless ($questions) {
    $questions = 10;
  }
  unless ($level) {
    $level = 3;
  }
  if ($solentry ne 'decimals' and $solentry ne 'fractions') {
    $solentry = 'fractions';
  }
  # Generate equation or check user answer
  if ($action eq 'start' or $action eq 'next') {
    $question++;
    # Generate equation
    ($equation, $solution, $solution1, $solution2) = generateEquation($level, $solentry, $questions);
    $usolution = ''; $usolution1 = 'none'; $usolution2 = 'none'; $evaluation = '';
  }
  elsif ($action eq 'check') {
    # Check user answer
    $equation = $params{'hequation'}; $equation =~ s/[^logx0-9\.\+\-\=\(\) \{\}]*//g;
    $equation =~ s/\{/<sub>/g; $equation =~ s/\}/<\/sub>/g;
    ($solution, $solution1, $solution2) = split(/;/, $params{'hsolution'});      # "decode" solution string (as stored in hidden field of website form)
    unless ($solution eq 'one' or $solution eq 'two' or $solution eq 'none') {
      $solution = '';
    }
    $solution1 =~ s/[^0-9\.\-\/]*//g; $solution2 =~ s/[^0-9\.\-\/]*//g;
    $usolution = $params{'solution'};
    if ($usolution eq 'one') {
      $usolution1 = $params{'solution1'};
      $usolution2 = '';
    }
    elsif ($usolution eq 'two') {
      $usolution = 'two';
      $usolution1 = $params{'solution2a'}; $usolution2 = $params{'solution2b'};
    }
    elsif ($usolution eq 'none') {
      $usolution1 = ''; $usolution2 = '';
    }
    else {
      $usolution = ''; $usolution1 = ''; $usolution2 = '';
    }
    $usolution1 =~ s/\,/\./g; $usolution2 =~ s/\,/\./g;                          # this allows using the comma as decimal separator
    # Test equation solutions, entered by user, for valid characters (XSS prevention)
    unless ($usolution1 =~ /^([0-9\.\-\/]*)$/) {
      $usolution1 = '';
    }
    unless ($usolution2 =~ /^([0-9\.\-\/]*)$/) {
      $usolution2 = '';
    }
    $correctanswer = 0;
    if ($usolution and $usolution eq $solution) {
      # If solution type (one, two, none) is correct, check solution(s)
      $correctanswer = 1;
      if ($usolution eq 'one') {
        # Check if (the one) solution is correct
        unless ($usolution1 eq $solution1) {
          $correctanswer = 0;
        }
      }
      # Check if (the two) solutions are correct
      elsif ($usolution eq 'two') {
        unless ($usolution1 eq $solution1 and $usolution2 eq $solution2) {
          $correctanswer = 0;
        }
      }
    }
    # User answer evaluation
    if ($correctanswer) {
      # Correct answer
      $evaluation = 'This is correct!';
      $correct++;
    }
    else {
      # False answer
      $evaluation = 'False! Correct answer is: ';
      # Display correct answer in this case
      if ($solution eq 'one') {
        $evaluation .= 'x = ' . $solution1;
      }
      elsif ($solution eq 'two') {
        $evaluation .= 'x = ' . $solution1 . ' or x = ' . $solution2;
      }
      else {
        $evaluation .= ' No solution';
      }
      $evaluation .= '.';
    }
  }
  # Read template HTML file
  my $template = "$app_dir\\equations4.template.html";
  open(my $input, "<", $template)
    or die "Can't open template file $template: $!";
  my @lines = <$input>;
  close($input);
  # Create the webpage
  foreach my $line (@lines) {
    chomp($line);
    if ($line) {
      if (substr($line, 0, 1) eq '#') {                                        # a '#' at beginning of line indicates that line contains a tag
        $line = substr($line, 1);
        if ($line =~ /#questions#/) {
          $line =~ s/#questions#/$questions/;
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#readonly#//;
          }
          else {
            $line =~ s/#readonly#/readonly="readonly"/;                        # disable modification of questions number during test
          }
        }
        elsif ($line =~ /#checkedl1#/) {
          if ($level == 1) {
            $line =~ s/#checkedl1#/checked="checked"/;
          }
          else {
            $line =~ s/#checkedl1#//;
          }
        }
        elsif ($line =~ /#checkedl2#/) {
          if ($level == 2) {
            $line =~ s/#checkedl2#/checked="checked"/;
          }
          else {
            $line =~ s/#checkedl2#//;
          }
        }
        elsif ($line =~ /#checkedl3#/) {
          if ($level == 3) {
            $line =~ s/#checkedl3#/checked="checked"/;
          }
          else {
            $line =~ s/#checkedl3#//;
          }
        }
        elsif ($line =~ /#checkedsd#/) {
          if ($solentry eq 'decimals') {
            $line =~ s/#checkedsd#/checked="checked"/;
          }
          else {
            $line =~ s/#checkedsd#//;
          }
        }
        elsif ($line =~ /#checkedsf#/) {
          if ($solentry eq 'fractions') {
            $line =~ s/#checkedsf#/checked="checked"/;
          }
          else {
            $line =~ s/#checkedsf#//;
          }
        }
        elsif ($line =~ /#equationcount#/) {
          if ($action eq 'init' or $action eq 'new') {
            $line =~ s/#equationcount#/Equation/;
          }
          else {
            $line =~ s/#equationcount#/Equation $question\/$questions/;        # display actual question number
          }
        }
        elsif ($line =~ /#equation#/) {                                        # display the equation
          my $b1 = '<span class="bold">'; my $b2 = '</span>';
          $line =~ s/#equation#/$b1$equation$b2/;
        }
        elsif ($line =~ /#checkeds1#/) {
          if ($usolution eq 'one') {
            $line =~ s/#checkeds1#/checked="checked"/;                         # check 'one solution' radiobutton
            $line =~ s/#solution1#/$usolution1/;                               # display user's solution
          }
          else {
            $line =~ s/#checkeds1#//;
            $line =~ s/#solution1#//;
          }
        }
        elsif ($line =~ /#checkeds2#/) {
          if ($usolution eq 'two') {
            $line =~ s/#checkeds2#/checked="checked"/;                         # check 'two solutions' radiobutton
            $line =~ s/#solution2a#/$usolution1/;                              # display user's solution 1
            $line =~ s/#solution2b#/$usolution2/;                              # display user's solution 2
          }
          else {
            $line =~ s/#checkeds2#//;
            $line =~ s/#solution2a#//;
            $line =~ s/#solution2b#//;
          }
        }
        elsif ($line =~ /#checkeds0#/) {
          if ($usolution eq 'none') {
            $line =~ s/#checkeds0#/checked="checked"/;                         # check 'no solution' radiobutton
          }
          else {
            $line =~ s/#checkeds0#//;
          }
        }
        elsif ($line =~ /#eval#/) {
          if ($evaluation) {
            $line =~ s/#eval#/$evaluation/;
            if ($correctanswer) {
              $line =~ s/#class#/class="bold"/;                                # display evaluation in black bold, if correct answer
            }
            else {
              $line =~ s/#class#/class="red"/;                                 # display evaluation in red bold, if false answer
            }
          }
          else {
            $line =~ s/#eval#/&nbsp;/;                                         # no evaluation displayed (case if question is asked)
            $line =~ s/ #class#//;
          }
        }
        elsif ($line =~ /#button#/) {
          my $button = ucfirst($nextaction);
          $line =~ s/#button#/$button/;                                        # set button caption to next action
        }
        elsif ($line =~ /#table#/) {
          # Display test evaluation table (at end of test)
          if ($nextaction eq 'new' and $questions >= 5) {                      # evaluate only, if there were at least 5 questions
            my $false = $questions - $correct;
            my $success = 100 * ($correct / $questions); $success = int($success + 0.5);
            # Use spaces (&nbsp;) to right-align the count values
            my $tquestions = sprintf("%4u", $questions); $tquestions =~ s/ /&nbsp; /g;
            my $tcorrect = sprintf("%4u", $correct); $tcorrect =~ s/ /&nbsp; /g;
            $false = sprintf("%4u", $false); $false =~ s/ /&nbsp; /g;
            $success = sprintf("%3u", $success); $success =~ s/ /&nbsp; /g;
            # Create table HTML
            my $table = '<table border="1" style="padding:5px">';
            $table .= '<tr><th colspan="2" align="center" style="padding:5px">Evaluation</td></tr>';
            $table .= '<tr><td style="padding:5px">Questions</td><td style="padding:5px">' . $tquestions . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Correct</td><td style="padding:5px">' . $tcorrect . '</td></tr>';
            $table .= '<tr><td style="padding:5px">False</td><td style="padding:5px">' . $false . '</td></tr>';
            $table .= '<tr><td style="padding:5px">Success</td><td style="padding:5px">' . $success . '%</td></tr>';
            $table .= '</table>';
            $line =~ s/#table#/$table/;
          }
          # Display nothing if test not yet done
          else {
            $line =~ s/#table#/&nbsp;/;
          }
        }
        elsif ($line =~ /#hquestions#/) {
          $line =~ s/#hquestions#/$questions/;                                 # save questions number to hidden field
        }
        elsif ($line =~ /#hlevel#/) {
          $line =~ s/#hlevel#/$level/;                                         # save level to hidden field
        }
        elsif ($line =~ /#hsolentry#/) {
          $line =~ s/#hsolentry#/$solentry/;                                   # save result entry format to hidden field
        }
        elsif ($line =~ /#hquestion#/) {
          $line =~ s/#hquestion#/$question/;                                   # save actual question number to hidden field
        }
        elsif ($line =~ /#hequation#/) {
          my $hequation = $equation;
          $hequation =~ s/<sub>/\{/g; $hequation =~ s/<\/sub>/\}/g;
          $line =~ s/#hequation#/$hequation/;                                  # save equation string to hidden field
        }
        elsif ($line =~ /#hsolution#/) {
          # Solution is stored as string: solution-number;solution1;solution2
          $line =~ s/#hsolution#/$solution;$solution1;$solution2/;             # save actual solution string to hidden field
        }
        elsif ($line =~ /#hcorrect#/) {
          $line =~ s/#hcorrect#/$correct/;                                     # save number of correct answers to hidden field
        }
      }
      # Print file-line (with tags replaced) to webpage
      unless ($line =~ /#/) {
        print "$line\n";
      }
    }
  }
}

# ----------------------------
# Generate logartithm equation
# ----------------------------

sub generateEquation {

  my ($level, $solentry, $questions) = @_;
  my $equation; my  $result;
  my $solution = ''; my $solution1 = ''; my $solution2 = '';
  my $a1 = 0; my $a2 = 0; my $a3 = 0; my $b1 = 0; my $b2 = 0; my $b3 = 0; my $c = 0; my $base = 1; my @results;
  # Equation type (random) variables
  my $r = int(rand(11)); my $r1 = int(rand(3)); my $r2 = int(rand(2));
  # Only a given number (1/5 of questions) should have no solution
  my $allowNoSolution = 0;
  if (int(rand($questions)) <= int(rand($questions / 5))) {
    $allowNoSolution = 1;
  }
  # Main equation type (depending on level)
  my $eqtype;
  if ($level == 1) {
    $eqtype = 1;
  }
  elsif ($level == 2) {
    if ($r <= 2) {
      $eqtype = 1
    }
    else {
      $eqtype = 2;
    }
  }
  elsif ($level == 3) {
    if ($r == 0) {
      $eqtype = 1;
    }
    elsif ($r <= 2) {
      $eqtype = 2;
    }
    elsif ($r <= 6) {
      $eqtype = 3;
    }
    else {
      $eqtype = 4;
    }
  }
  # Repeat generating an equation until a valid (wanted) one has been found
  my $ok; my $mess;
  do  {
    $ok = 1;
    do {
      $ok = 1; my $logterm; my $eqresult;
      # Equation type: log(a1x + b1) = log(a2x + b2)
      if ($eqtype == 1) {
        ($logterm, $base, $a1, $b1) = GenerateLogTerm($base, 1);
        $equation = $logterm;
        ($logterm, $base, $a2, $b2) = GenerateLogTerm($base, 0);
        $equation .= ' = ' . $logterm;
        ($eqresult, $mess) = SolveEquation1($a1 - $a2, $b2 - $b1, $solentry);
      }
      # Equation type: log(a1x + b1) = c
      elsif ($eqtype == 2) {
        ($logterm, $base, $a1, $b1) = GenerateLogTerm($base, 1);
        $c = GenerateConstTerm($base);
        $equation = $logterm . ' = ' . $c;
        ($eqresult, $mess) = SolveEquation1($a1, $base ** $c - $b1, $solentry);
      }
      # Equations with logarithm addition and subtraction
      elsif ($eqtype == 3) {
        ($logterm, $base, $a1, $b1) = GenerateLogTerm($base, 1);
        $equation = $logterm;
        if ($r1 == 0) {
          $equation .= ' = ';
          # Equation type: log(a1x + b1) = log(a2x + b2) - log(a3x + b3)
          if ($r2 == 0) {
            ($logterm, $base, $a2, $b2) = GenerateLogTerm($base, 0);
            $equation .= $logterm . ' - ';
            ($logterm, $base, $a3, $b3) = GenerateLogTerm($base, 0);
            $equation .= $logterm;
            ($eqresult, $mess) = SolveEquation2($a1 * $a3, $a1 * $b3 + $b1 * $a3 - $a2, $b1 * $b3 - $b2, $solentry);
          }
          # Equation type: log(a1x + b1) = log(a2x + b2) + log(a3x + b3)
          else {
            ($logterm, $base, $a2, $b2) = GenerateLogTerm($base, 0);
            $equation .= $logterm . ' + ';
            ($logterm, $base, $a3, $b3) = GenerateLogTerm($base, 0);
            $equation .= $logterm;
            ($eqresult, $mess) = SolveEquation2($a2 * $a3, $a2 * $b3 + $b2 * $a3 - $a1, $b2 * $b3 - $b1, $solentry);
          }
        }
        # Equation type: log(a1x + b1) + log(a2x + b2) = log(a3x + b3)
        elsif ($r1 == 1) {
          $equation .= ' + ';
          ($logterm, $base, $a2, $b2) = GenerateLogTerm($base, 0);
          $equation .= $logterm . ' = ';
          ($logterm, $base, $a3, $b3) = GenerateLogTerm($base, 0);
          $equation .= $logterm;
          ($eqresult, $mess) = SolveEquation2($a1 * $a2, $a1 * $b2 + $b1 * $a2 - $a3, $b1 * $b2 - $b3, $solentry);
        }
        # Equation type: log(a1x + b1) - log(a2x + b2) = log(a3x + b3)
        else {
          $equation .= ' - ';
          ($logterm, $base, $a2, $b2) = GenerateLogTerm($base, 0);
          $equation .= $logterm . ' = ';
          ($logterm, $base, $a3, $b3) = GenerateLogTerm($base, 0);
          $equation .= $logterm;
          ($eqresult, $mess) = SolveEquation2($a2 * $a3, $a2 * $b3 + $b2 * $a3 - $a1, $b2 * $b3 - $b1, $solentry);
        }
      }
      # Equation type: log(a1x + b1) + log(a2x + b2) = c and log(a1x + b1) - log(a2x + b2) = c
      else {
        ($logterm, $base, $a1, $b1) = GenerateLogTerm($base, 1);
        $equation = $logterm;
        if ($r2 == 0) {
          $equation .= ' + '
        }
        else {
          $equation .= ' - ';
        }
        ($logterm, $base, $a2, $b2) = GenerateLogTerm($base, 0);
        $equation .= $logterm;
        $c = GenerateConstTerm($base);
        $equation .= ' = ' . $c;
        if ($r2 == 0) {
          ($eqresult, $mess) = SolveEquation2($a1 * $a2, $a1 * $b2 + $b1 * $a2, $b1 * $b2 - $base ** $c, $solentry);
        }
        else {
          ($eqresult, $mess) = SolveEquation1($a1 - $a2 * $base ** $c, $b2 * $base ** $c - $b1, $solentry);
        }
      }
      # Check message returned by the (simple) equation solving routine. If it is not empty, the equation is not
      # as wanted (e.g. infinity of solutions, complex roots) => generate a new one
      if ($mess) {
        $ok = 0;
      }
      else {
        $result = $eqresult;
      }
    } until ($ok);
    # Valid equation found: Determine valid solutions
    if ($result =~ /\;/) {
      # A ';' in the result string indicates that there are actually two solutions (for the simple equation)
      $results[1] = substr($result, 0, index($result, ';'));
      $results[2] = substr($result, index($result, ';') + 1);
    }
    else {
      # Otherwise there is actually one single solution (for the simple equation)
      $results[1] = $result; $results[2] = '';
    }
    my $resok = 0; my $res;
    # Check how many of the solutions found are valid (i.e. don't give the log of a number <= 0)
    for (my $i = 1; $i <= 2; $i++) {
      # Transform result string to number (in the case where solutions are given as fractions)
      if ($results[$i]) {
        if ($results[$i] !~ /\//) {
          # This is a real number
          $res = $results[$i];
        }
        else {
          # This is a fraction
          $res = substr($results[$i], 0, index($results[$i], '/')) / substr($results[$i], index($results[$i], '/') + 1);
        }
        # In order to keep this solution as valid solution of the logarithm equation, check for log > 0
        unless ((($a1 * $res + $b1 <= 0) or ((($a2 != 0) or ($b2 != 0)) and ($a2 * $res + $b2 <= 0)) or ((($a3 != 0) or ($b3 != 0)) and ($a3 * $res + $b3 <= 0)))) {
          $resok += $i;                                                        # $resok will contain all info necessary to only retain the valid solution(s)
        }
      }
    }
    if ($resok == 0) {
      # $resok wasn't incremented at all; thus: always negative value -> equation has no solution
      $solution = 'none';
      $solution1 = ''; $solution2 = '';
    }
    elsif ($resok == 1 or $resok == 2) {
      # $resok was incremented once; thus: solution 1 or solution 2 (but not both) don't give negative value -> equation has one solution
      $solution = 'one';
      $solution1 = $results[$resok]; $solution2 = '';
    }
    else {
      # $resok = 3 (was incremented twice): never negative value -> equation has two solutions
      $solution = 'two';
      $solution1 = $results[1]; $solution2 = $results[2];
    }
    # Only a limited "no solution" equations wanted: check if keep equation or generate a new one
    if ($solution eq 'none') {
      unless ($allowNoSolution) {
        $ok = 0;
      }
    }
  } until ($ok);
  return($equation, $solution, $solution1, $solution2);

}

# ---------------------------------------------
# Randomly generate equation "log(ax + b)" term
# ---------------------------------------------

sub GenerateLogTerm {

  my ($base, $randombase) = @_; my $logterm; my $a; my $b;
  # If $randombase is true, get random logarithm base between 2 and 10, otherwise use the base as given by second argument
  if ($randombase) {
    $base = int(rand(8)) + 2;
  }
  my $ok;
  do {
    $ok = 1;
    $a = int(rand(21)) - 10; $b = int(rand(21)) - 10;                          # a and b: integers between -10 and 10
    if ($a == 0 and $b <= 0) {                                                 # logarithm argument can't be negative
      $ok = 0;
    }
  } until $ok;
  $logterm = 'log';
  unless ($base == 10) {
    $logterm .= '<sub>' . $base . '</sub>';                                    # add logarithm base as subscript
  }
  $logterm .= '(' . FormatEquation($a, $b) . ')';                              # pretty format the "ax + b" logarithm argument
  return($logterm, $base, $a, $b);

}

# ----------------------------------------
# Randomly generate equation constant term
# ----------------------------------------

sub GenerateConstTerm {

  my ($base) = @_; my $c;
  do {
    $c = int(rand(10) )+ 1;
  } until ($base ** $c <= 100);                                                # logarithm-base ** constant should be <= 100
  return $c;

}

# -------------------------
# Solve 1st degree equation
# -------------------------

sub SolveEquation1 {

  # The sub returns the root (as decimal or fraction) or a message if there is no / an infinity of solutions

  my ($a, $b, $solentry) = @_;
  my  $res = ''; my $mess = '';
  if ($a == 0) {
    if ($b == 0) {
      $res = 'infinity of solutions'; $mess = $res;
    }
    else {
      $res = 'no solution'; $mess = $res;
    }
  }
  else {
    $res = FormatNumber($b, $a, $solentry, 0);                                 # root as rounded decimal or reduced fraction
  }
  return($res, $mess);

}

# -------------------------
# Solve 2nd degree equation
# -------------------------

sub SolveEquation2 {

  # The sub returns the root(s) (as decimals or fractions) or a message if there is no real solution (or if it is a 1st degree equation)
  # If the square root of Delta isn't an integer, there is also a message returned. AS in this case, it's not possible to get expressed
  # the roots as fractions, such equations will be filtered out and not used for the exercises

  my ($a, $b, $c, $solentry) = @_;
  my $res = ''; my $mess = '';
  if ($a == 0) {
    $mess = 'no 2nd degree equation';
  }
  else {
    my $delta = $b * $b - 4 * $a * $c;
    if ($delta < 0) {
      $mess = 'no real solution';
    }
    else {
      if (sqrt($delta) != int(sqrt($delta))) {
        $res = FormatNumber(-$b + sprintf('%.0f', sqrt($delta)), 2 * $a, $solentry, 1);            # 1 root as rounded decimal
        if ($delta > 0) {
          $res .= ';' . FormatNumber(-$b - sprintf('%.0f', sqrt($delta)), 2 * $a, $solentry, 1);   # 2 roots as rounded decimals separated by ";"
        }
        $mess = 'no integer square root';
      }
      else {
        $res = FormatNumber(-$b + sprintf('%.0f', sqrt($delta)), 2 * $a, $solentry, 0);            # 1 root as rounded decimal or fraction
        if ($delta > 0) {
          $res .= ';' . FormatNumber(-$b - sprintf('%.0f', sqrt($delta)), 2 * $a, $solentry, 0);   # 2 roots as rounded decimals or fractions separated by ";"
        }
      }
    }
  }
  return($res, $mess);

}

# -----------------------
# Greatest Common Divisor
# -----------------------

sub GCD {

  my ($n1, $n2) = @_;
  my $n0 = 1; my $nr;
  do {
    $nr = $n1 % $n2;
    if ($nr == 0) {
      $n0 = $n2
    }
    else {
      $n1 = $n2;
      $n2 = $nr;
    }
  } until ($nr == 0);
  return($n0);

}

# ---------------------------------
# "Pretty" format equation (ax + b)
# ---------------------------------

sub FormatEquation {

  my ($a, $b) = @_; my $equation;
  $equation = '';
  if ($a == 0) {                                                               # print '0' instead of '0x'
    if ($b == 0) {
      $equation = '0'
    }
    else {
      $equation = $b;
    }
  }
  else {
    if ($a == 1) {                                                             # print 'x' instead of '1x'
      $equation = 'x';
    }
    elsif ($a == -1) {                                                         # print '-x' instead of '-1x'
      $equation = '-x';
    }
    elsif ($a != 0) {
      $equation = $a . 'x';
    }
    if ($b > 0) {                                                              # "pretty" display for +/-/0 constant
      $equation .= ' + ' . $b;
    }
    elsif ($b < 0) {
      $equation .= ' - ' . abs($b);
    }
  }
  return($equation);

}

# --------------------------------------
# Format number (as fraction or decimal)
# --------------------------------------

sub FormatNumber {

  # The arguments $n and $d are the nominator resp. denominator of a fraction
  # $solentry tells the sub if the number should be expressed as decimal or fraction
  # If $alwaysDec is True, $solentry is overwritten and the number will be expressed as decimal

  my ($n, $d, $solentry, $alwaysDec) = @_;
  my $numberN; my $numberD; my $numberGCD; my $number;
  if ($n / $d == int($n / $d)) {                                               # display integers just as integers
    $number = sprintf('%.0f', $n / $d);
  }
  else {
    # Display number as decimal
    if ($alwaysDec or $solentry eq 'decimals') {
      if (10 * ($n / $d) == int(10 * ($n / $d))) {                             # decimal with 1 significant decimal digit
        $number = sprintf('%.1f', $n / $d);
      }
      elsif (100 * ($n / $d) == int(100 * ($n / $d))) {                        # decimal with 2 significant decimal digits
        $number = sprintf('%.2f', $n / $d);
      }
      else {                                                                   # all other cases: decimal rounded to 3 decimal digits
        $number = sprintf('%.3f', $n / $d);
      }
    }
    # Display number as reduced fraction
    else {
      # Reduce the fraction
      $numberGCD = GCD($n, $d);
      $numberN = int($n / $numberGCD);
      $numberD = int($d / $numberGCD);
      # Do not use negative denominators
      if ($numberD < 0) {
        $numberN = -$numberN; $numberD = -$numberD;
      }
      # Construct the fraction string
      $number = $numberN . '/' . $numberD;                                     # reduced fraction (with minus sign always for nominator)
    }
  }
  return($number);

}

# ---------------------------------------------
# Remove non-significant zeros from user answer
# ---------------------------------------------

sub removeZeros {

  # This "bizarre code" actually is a "direct translation" from the corr. Free Pascal Equations4 routine...

  my ($eqAnswer) = @_; my $eqAnsw;
  $eqAnsw = $eqAnswer;
  # Do only if results are decimal numbers
  if ($solentry eq 'decimal') {
    my $p = index($eqAnsw, ',');
    if ($p == -1) {
      $p = index($eqAnsw, '.');
    }
    if ($p != -1) {
      if (substr($eqAnsw, -3) eq '000') {
        $eqAnsw = substr($eqAnsw, 0, length($eqAnsw) - 3);
      }
      elsif (substr($eqAnsw, -2) eq '00') {
        $eqAnsw = substr($eqAnsw, 0, length($eqAnsw) - 2);
      }
      elsif (substr($eqAnsw, -1) eq '0') {
        $eqAnsw = substr($eqAnsw, 0, length($eqAnsw) - 1);
      }
      if (substr($eqAnsw, -1) eq ',' or substr($eqAnsw, -1 eq '.')) {          # remove decimal separator
        $eqAnsw = substr($eqAnsw, 0, length($eqAnsw) - 1);
      }
    }
  }
  return($eqAnsw);

}
